# package stuff

  // We're going to spawn the package, but before we do, we read its template
  // library.  To do either we need to read its "package config" file, which
  // is in 'package:pkg_name/.dart/.dart_tool/package_config.json.'
  // To find this file, we go through the user's "dart config", which is in
  // $HOME/.dart.d.  That dir contains the pubspec.yaml file where the user
  // lists all the deps he/she might want to use across projects;
  // in particular, it lists the Dartrix app and any external (3rd-party)
  // Dartrix template packages the user has installed.
  // So our first step is to obtain the package_config.json file from the
  // user's dart config dir, and from it obtain the location of the
  // desired template package. From there we can 1) read the templates in
  // the package, and 2) spawn the package itself
  // (i.e. package:pkg_name/dartrix.dart).


  // WARNING: for pub global activateds, the current dir of the script contains
  // .packages, which is the value of Isolate.packageConfig, but it does NOT
  // contain all of the subdirs of the original pkg root. It only the bin dir,
  // plus the pub stuff (.dart_tool, .packages, pubspec.lock).

  // e.g.
  // $ l ~/.pub-cache/global_packages/stagehand/
  // total 8.0K
  // drwxr-xr-x 3 gar staff  102 Mar 10 18:40 .dart_tool/
  // -rw-r--r-- 1 gar staff 2.9K Mar 10 18:40 .dart_tool/package_config.json
  // -rw-r--r-- 1 gar staff 1.3K Mar 10 18:40 .packages
  // drwxr-xr-x 3 gar staff  102 Mar 10 18:40 bin/
  // -rw-r--r-- 1 gar staff 1.3M Mar 10 18:40 bin/stagehand.dart.snapshot.dart2
  // -rw-r--r-- 1 gar staff 2.4K Mar 10 18:40 pubspec.lock

  // So to find the templates/ dir, we have to look it up in the .packages file
  // using findPackageConfigUri.  this is a v1 pkg config, i.e. a .packages
  // file, so back up one segment: String libDir =
  // path.dirname(packageConfigUri.path); var templatesRoot =
  // path.dirname(packageConfigUri.path) + '/templates'; List
